/*
 * 商户活动配置
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MerchantParamSetController : BaseController
    {
        public MerchantParamSetController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
        }

        #region 商户活动配置列表

        /// <summary>
        /// 根据条件查询商户活动配置列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MerchantParamSet data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询商户活动配置列表

        /// <summary>
        /// 商户活动配置列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MerchantParamSet data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();



            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MerchantParamSet", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }
            return Json(obj);
        }

        #endregion

        #region 增加商户活动配置

        /// <summary>
        /// 增加或修改商户活动配置信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加商户活动配置

        /// <summary>
        /// 增加或修改商户活动配置信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MerchantParamSet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("IsAll", data.IsAll); //是否收全额
            Fields.Add("MinPayMoney", data.MinPayMoney); //订单参与门槛
            Fields.Add("GetPercent", data.GetPercent); //商家实收比例
            Fields.Add("ProfitDays", data.ProfitDays); //分红期限（天）
            Fields.Add("DiviPercent", data.DiviPercent); //最大分红比例
            Fields.Add("DiviPersons", data.DiviPersons); //单笔订单分红人数

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Add("MerchantParamSet", Fields, 0);
            AddSysLog(data.Id.ToString(), "MerchantParamSet", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改商户活动配置

        /// <summary>
        /// 增加或修改商户活动配置信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.Id = Id.ToString();


            MerchantParamSet editData = db.MerchantParamSet.FirstOrDefault(m => m.Id == Id) ?? new MerchantParamSet();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商户活动配置

        /// <summary>
        /// 增加或修改商户活动配置信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MerchantParamSet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("IsAll", data.IsAll); //是否收全额
            Fields.Add("MinPayMoney", data.MinPayMoney); //订单参与门槛
            Fields.Add("GetPercent", data.GetPercent); //商家实收比例
            Fields.Add("ProfitDays", data.ProfitDays); //分红期限（天）
            Fields.Add("DiviPercent", data.DiviPercent); //最大分红比例
            Fields.Add("DiviPersons", data.DiviPersons); //单笔订单分红人数

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);

            int Id = 0;
            bool check = db.MerchantParamSet.Any(m => m.Id == data.Id);
            if (!check)
            { 
                Id = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Add("MerchantParamSet", Fields, 0);
            }
            else
            {
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantParamSet", Fields, data.Id);
                Id = data.Id;
            }
            AddSysLog(data.Id.ToString(), "MerchantParamSet", "update");
            db.SaveChanges();

            MerchantParamSet item = db.MerchantParamSet.FirstOrDefault(m => m.Id == Id) ?? new MerchantParamSet();
            RedisDbconn.Instance.Set("MerchantParamSet:" + Id, item);

            return "success";
        }

        #endregion

        #region 删除商户活动配置信息

        /// <summary>
        /// 删除商户活动配置信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MerchantParamSet", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantParamSet", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MerchantParamSet", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantParamSet", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MerchantParamSet", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantParamSet", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Sort("MerchantParamSet", Sort, Id);

            AddSysLog(Id.ToString(), "MerchantParamSet", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.MerchantParamSet.Add(new MerchantParamSet()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "MerchantParamSet", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MerchantParamSet data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MerchantParamSet", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MerchantParamSet", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
